#once

#include "library.s"
#include "lcd5110.s"

; Library Functions
; Demo

;;;;;;;;;;;;;;;;;;;;;;;;

Demo_Str1:
    #d "16-bit Serial\0"
Demo_Str2:
    #d "Homebrew CPU\0"
Demo_Str3:
    #d 0x7E, "8 ICs only!!!\0"
Demo_Str4:
    #d 0x7E, "768kB FLASH  \0"
Demo_Str5:
    #d 0x7E, "128kB SRAM\0"
Demo_Str6:
    #d 0x7E, "1-bit ALU    \0"
Demo_Str7:
    #d 0x7E, "1-bit Flag   \0"
Demo_Str8:
    #d 0x7E, "52 16-bit\0"
Demo_Str9:
    #d "instructions \0"
Demo_Str10:
    #d 0x7E, "10 MHz clock \0"
Demo_Str11:
    #d 0x7E, "cca 0.012MIPS\0"
Demo_Str12:
    #d 0x7E, "Testing LEDs\0"
Demo:
    PUSH_PC
    PUSH RA
    PUSH RB
    CALL WaitForButton
    LCD_SetXY 3, 0
    LCD_WriteDelayedStrF delay10MHz_ms(60), Demo_Str1
    LCD_SetXY 6, 1
    LCD_WriteDelayedStrF delay10MHz_ms(60), Demo_Str2
    LCD_SetXY 0, 2
    LDI RA, 83
    LDI RB, 0x24
.loop1:
    DelayCycles delay8MHz_ms(11)
    OUT_LCD RB
    DEC RA
    BRFC .loop1
    DelayCycles delay8MHz_ms(500)
    LCD_SetXY 1, 3
    LCD_WriteDelayedStrF delay10MHz_ms(60), Demo_Str3
    DelayCycles delay8MHz_ms(500)
    LCD_WriteDelayedStrF delay10MHz_ms(60), Demo_Str4
    DelayCycles delay8MHz_ms(500)
    LCD_WriteDelayedStrF delay10MHz_ms(60), Demo_Str5
    CALL WaitForButton
    CALL LCD_Clear
    LCD_SetXY 1, 0
    LCD_WriteDelayedStrF delay10MHz_ms(60), Demo_Str6
    DelayCycles delay8MHz_ms(500)
    LCD_WriteDelayedStrF delay10MHz_ms(60), Demo_Str7
    DelayCycles delay8MHz_ms(500)
    LCD_WriteDelayedStrF delay10MHz_ms(60), Demo_Str8
    LCD_SetXY 7, 3
    LCD_WriteDelayedStrF delay10MHz_ms(60), Demo_Str9
    DelayCycles delay8MHz_ms(500)
    LCD_WriteDelayedStrF delay10MHz_ms(60), Demo_Str10
    DelayCycles delay8MHz_ms(500)
    LCD_WriteDelayedStrF delay10MHz_ms(60), Demo_Str11
    CALL WaitForButton
    CALL Compute_Pi_32
    CALL LCD_Clear
    LCD_SetXY 1, 2
    LCD_WriteDelayedStrF delay10MHz_ms(60), Demo_Str12
    LDI FA, 5
    CALL LCD_SetY
    LDI FA, 0
    CALL LCD_SetX
    CALL WaitForButton
    LDI RA, 1
.loop_led:
    LDI RB, 7-1
.loop_led_left:
    LSL RA
    OUT_LCD RA
    ;DelayCycles delay8MHz_ms(100)
    DEC RB
    BRFC .loop_led_left
    LDI RB, 7-1
    ;DelayCycles delay8MHz_ms(100)
.loop_led_right:
    LSR RA
    OUT_LCD RA
    ;DelayCycles delay8MHz_ms(100)
    DEC RB
    BRFC .loop_led_right
    ;DelayCycles delay8MHz_ms(100)
    JMP .loop_led
    POP RB
    POP RA
    POP_PC
    HALT
